#!/usr/bin/bash

#yellow start 
	C14="\e[1;33m"
#blue start 
	C01="\e[0;34m"
#color end
	CE="\e[0m"
#light green start
	C10="\e[1;32m"

HOMEDIR="/home/pi"
ROOTDIR="/opt/retropie"
CONFIGDIR="$ROOTDIR/configs"
ROMS="$HOMEDIR/RetroPie/roms/arcade"
RETROPIE="$HOMEDIR/RetroPie"

BASEDIR="https://archive.org/download/mame-0.245-roms-split/MAME%200.245%20ROMs%20%28split%29/"

OSK="python $ROOTDIR/admin/joy2key/osk.py"

function presskey() {
  echo ""
  echo -e $C10"Press a key to continue..."$CE
  read -n 1
}

check_internet(){
 ping -c 1 www.google.com 2>&1 >/dev/null
 if [ $? != 0 ]; then
  read -p "Internet Connection Not Available. Press "$C14"ENTER"$CE" to continue..."
  echo 1
 fi
}

check_command(){
  if ! command -v "$1" 2>&1 >/dev/null
  then
    echo "$1 could not be found."
    return 1
  fi
}

function getlist() {
  echo "Retrieving ROM list from Archive.org..."
  curl "$BASEDIR" > /tmp/roms.htm
}

function getroms() {
clear
if [[ ! -f /tmp/roms.htm ]]; then
  getlist
else
  echo "Using previous list..."
  sleep 2
fi


ROM=$(cat /tmp/roms.htm | grep "\".*.zip\"" -oh | sed "s/\"//g" | fzf --reverse -m --header 'Press TAB for multi-select')

if [[ ! -z "${ROM}" ]]; then
  clear
  #wget "http:$ROM"
  echo "$ROM" | while read -r item; do
    wget "$BASEDIR$item" -O "$ROMS/$item" -c
  done
  echo .
  echo "---------------------------------"
  echo -e "$C14Check if download was successful and restart EmulationStation to build list.$CE"
  read -p "Press a key to continue... " -n1 -s
fi
}

function about() {
  clear
  echo -e "$C14[] MAME Rom Downloader for Retropie!$CE"
  echo ""
  echo "A script to download MAME roms from Archive.org."
  echo "You need a keyboard, internet connection and FZF utility."
  echo ""
  echo -e $C14"Made by XQTR // https://cp737.net"$CE
  presskey
}

function mnu_main() {
  option=""
  while [ -z "$option"  ]
  do 
    option=$(echo "1. Download ROM
2. Delete old list
3. Download rom list
A. About
E. Edit script
X. Exit" | fzf --reverse --header "Main Menu")

    if [ ! -z "$option" ]
    then
      ch="$option"
      case $ch in
      # /home is selected
        1.*) getroms;;
        2.*) clear;rm -f /tmp/roms.htm;echo "Deleted old list.";presskey;;
        3.*) clear;getlist;presskey;;
        A.*) about;;
        E.*) nano "$RETROPIE/retropiemenu/mameroms.sh";;
        X.*) break;;
        esac
     
    # Cancel is pressed
    #else
    #        exec $maindir/main.sh
    fi
  option=""
  done
}

clear

# Check if FZF exists, must be for root user
check_command fzf
if [ $? != 0 ]; then
  echo "FZF command doesn't exit. Install it to use this script."
  exit 1 
fi

check_internet
mnu_main
clear
